#include <iostream.h>

#include "master.h"
#include "process.h"

using namespace std;

CMaster::CMaster()
{
	running = true;
}

CMaster::~CMaster()
{
	for(LI i=the_processes.begin(); i != the_processes.end(); ++i)
	{
		CProcess *proc = *i;
		delete proc;
	}
	the_processes.clear();
}

void CMaster::addproc(CProcess *aProc)
{
	the_processes.push_front(aProc);
}

void CMaster::print_proc()
{
	for(LI i=the_processes.begin(); i!=the_processes.end(); ++i)
	{
		CProcess *proc = *i;
		cout << proc->name.c_str() << '\n';
		proc->print_tasks();
	}
}

void CMaster::start()
{
	while(running)
	{
		for(LI i=the_processes.begin(); i != the_processes.end(); ++i)
		{
			CProcess *proc = *i;
			proc->run_task();
		}
	}
}
