#ifndef ___TASKH___
#define ___TASKH___

#include <list>
#include <string>

using namespace std;

class CProcess;
class CState;

class CTask
{
	public:
		CTask(CProcess *myProc, string name);		// continuous
		CTask(CProcess *myProc, string name, short priority, float int_time);	// Sample time
		CTask(CProcess *myProc, string name, float int_time); // sim ISR
		
		virtual ~CTask();

		virtual run();
		addstate(CState *);

		const float int_time;
		float lastrun;
		const string name;
		short priority;

		string message;		// for debugging

	private:
		const CProcess *myProc;
		CState *CurrentState;
		bool first_run;
		
		list<CState *>my_states;
		typedef list<CState *>::const_iterator LI;
};

#endif
