/*************************************************
 * Most of this code came from sourceforge.net's *
 * 	code snippets section.                   *
 *		Original Author: I. Chuang	 *
 *************************************************/

#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <signal.h>
#include <sys/types.h>
#include <string.h>
#include <sys/wait.h>
#include <ctype.h>
#include <sys/time.h>

int kbdcheck(int fd)
{
	fd_set rfds;
	struct timeval tv;
	int retval;

        FD_ZERO(&rfds);
        FD_SET(fd,&rfds);

        tv.tv_sec = 0;
        tv.tv_usec = 10;

        retval = select(fd+1,&rfds,NULL,NULL,&tv);
        if (retval<0) {
        	return(-1);
		perror("select");
	}

        if(!retval) return(0);
                               
        if(FD_ISSET(fd,&rfds)){       /* data available from serial line */
        	return(1);
	}

	return(0);
}
